#!/usr/bin/env python3
# Server controlling all actions on JURECA
from flask import Flask, request
from flask_restful import Resource, Api

app = Flask(__name__)
api = Api(app, prefix="/api")


@app.route("/")
def welcome():
    return """<h1>Welcome to ATLaS UI</h1>
API available <a href="/api">here</a>
    """


def get_json_data():
    assert request.is_json
    data = request.get_json()
    return data


class SetupTraining(Resource):
    def post(self):
        data = get_json_data()
        print(data)
        return "Thank you from JURECA!"

    def get(self):
        return "This is a test page!"


api.add_resource(SetupTraining, "/setup_training")

if __name__ == "__main__":
    app.run(debug=True, port=8000)
