
var Configuration = {
    config: {},
    drawingTools: ["select", "draw", "draw-polygon", "text", "point",
        "simplify", "addpoint", "delpoint", "addregion", "delregion", 
        "splitregion", "rotate", "flip", "snappoint", "handle", 
        "save", "copy", "paste", "delete"],

    init: function() {
        var me = this;
        var def = $.Deferred();
        // load general microdraw configuration
        $.getJSON("configuration.json", function(data) {
            me.config = data;
            def.resolve();
        })
        return def.promise();
    },

    addConfig: function(config) {
        var me = this;
        for (var key in config) {
            if (config.hasOwnProperty(key)) {
                me.config[key] = config[key];
            }
        }
    },
    
    applyConfig: function() {
        var me = this;
        if( me.config.drawingEnabled == false ) {
            // remove drawing tools from ui
            for( var i = 0; i < me.drawingTools.length; i++ ){
                $("#" + me.drawingTools[i]).remove();
            }
        }
        for( var i = 0; i < me.config.removeTools.length; i++ ) {
            $("#" + me.config.removeTools[i]).remove();
        }
        if( me.config.useDatabase == false ) {
            $("#save").remove();
        }
        if( me.config.showCoordinates == false ) {
            $("#mouseCoordinates")[0].innerHTML = "";
            $("#rgbValues")[0].innerHTML = "";
        }

        if (me.config.defaultStrokeColor == undefined) 
            me.config.defaultStrokeColor = 'black'
        if (me.config.defaultStrokeWidth == undefined) 
            me.config.defaultStrokeWidth = 1;
        if (me.config.defaultFillAlpha == undefined) 
            me.config.defaultFillAlpha = 0.5;
        if (me.config.textStrokeWidth == undefined) 
            me.config.textStrokeWidth = 5;
        if (me.config.textFontSize == undefined) 
            me.config.textFontSize = 100;
        if (me.config.enableRegionMove == undefined)
            me.config.enableRegionMove = true;
    }

}
